require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_securitytemplate',
  dscmeta_resource_friendly_name: 'SecurityTemplate',
  dscmeta_resource_name: 'MSFT_SecurityTemplate',
  dscmeta_module_name: 'SecurityPolicyDsc',
  dscmeta_module_version: '1.0.0.0',
  docs: 'The DSC SecurityTemplate resource type.
         Automatically generated from version 1.0.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_path: {
      type: 'String',
      desc: 'The path to the desired security policy template (.inf)',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_issingleinstance: {
      type: "Enum['Yes']",
      desc: "Specifies the resource is a single instance, the value must be 'Yes'",
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
  },
)
